// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

PleskExt.Docker.UploadButton = Class.create(Jsw.SmallButton, {
    _fileInputId: null,
    _initConfiguration: function ($super, config) {
        $super(config);
        this._uploadPopupParams = this._getConfigParam('uploadPopupParams', {});
        this._handler = this.uploadHandler.bind(this);
        this._fileInputId = this._id + '-file-element';
    },

    _initComponentElement: function ($super) {
        $super();
        var fileInputElement = new Element('input', {
            type: 'file',
            name: 'file',
            id: this._fileInputId,
            multiple: false,
            style: 'display:none'
        });
        fileInputElement.observe('change', function (e) {
            var files = e.target.files || e.dataTransfer.files;
            this._uploadPopupParams.file = files[0];
            (new PleskExt.Docker.UploadPopup(this._uploadPopupParams)).start();
        }.bind(this));
        this._componentElement.insert({bottom: fileInputElement});
    },

    uploadHandler: function () {
        $(this._fileInputId).click();
    }
});
