// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

PleskExt.Docker.SizeUnits = {
    BYTE: 1,
    KILOBYTE: 1024,
    MEGABYTE: 1048576,
    GIGABYTE: 1073741824,
    TERABYTE: 1099511627776
};

PleskExt.Docker.Utils = {
    bytesConvert: function (value, precision, unit) {
        value += 0;
        var convertTo = !unit && unit in PleskExt.Docker.SizeUnits,
            sign = value >= 0 ? 1 : -1;

        switch (true) {
            case convertTo:
                break;
            case (value >= PleskExt.Docker.SizeUnits.TERABYTE):
                unit = PleskExt.Docker.SizeUnits.TERABYTE;
                break;
            case (value >= PleskExt.Docker.SizeUnits.GIGABYTE):
                unit = PleskExt.Docker.SizeUnits.GIGABYTE;
                break;
            case (value >= PleskExt.Docker.SizeUnits.MEGABYTE):
                unit = PleskExt.Docker.SizeUnits.MEGABYTE;
                break;
            case (value >= PleskExt.Docker.SizeUnits.KILOBYTE):
                unit = PleskExt.Docker.SizeUnits.KILOBYTE;
                break;
            default:
                unit = PleskExt.Docker.SizeUnits.BYTE;
                break;
        }

        value = value / unit;
        if (!precision || precision < 0) {
            precision = 0;
        }

        return sign * value.toFixed(precision);
    }
};
