<?php

namespace Docker\API\Normalizer;

use Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;
use Symfony\Component\Serializer\Normalizer\SerializerAwareNormalizer;

class TaskSpecPlacementNormalizer extends SerializerAwareNormalizer implements DenormalizerInterface, NormalizerInterface
{
    public function supportsDenormalization($data, $type, $format = null)
    {
        if ($type !== 'Docker\\API\\Model\\TaskSpecPlacement') {
            return false;
        }

        return true;
    }

    public function supportsNormalization($data, $format = null)
    {
        if ($data instanceof \Docker\API\Model\TaskSpecPlacement) {
            return true;
        }

        return false;
    }

    public function denormalize($data, $class, $format = null, array $context = [])
    {
        $object = new \Docker\API\Model\TaskSpecPlacement();
        if (property_exists($data, 'Constraints')) {
            $value = $data->{'Constraints'};
            if (is_array($data->{'Constraints'})) {
                $values = [];
                foreach ($data->{'Constraints'} as $value_1) {
                    $values[] = $value_1;
                }
                $value = $values;
            }
            if (is_null($data->{'Constraints'})) {
                $value = $data->{'Constraints'};
            }
            $object->setConstraints($value);
        }

        return $object;
    }

    public function normalize($object, $format = null, array $context = [])
    {
        $data  = new \stdClass();
        $value = $object->getConstraints();
        if (is_array($object->getConstraints())) {
            $values = [];
            foreach ($object->getConstraints() as $value_1) {
                $values[] = $value_1;
            }
            $value = $values;
        }
        if (is_null($object->getConstraints())) {
            $value = $object->getConstraints();
        }
        $data->{'Constraints'} = $value;

        return $data;
    }
}
