<?php
// Copyright 1999-2017. Parallels IP Holdings GmbH. All Rights Reserved.

namespace PleskExt\Upgrader;

/**
 * Broker for versions table.
 */
class Versions extends \Zend_Db_Table_Abstract
{
    protected $_name = 'version';

    public function getDbVersion()
    {
        if (!$this->exists()) {
            return '0';
        }
        return $this->fetchAll()->current()->dbVersion;
    }

    public function setDbVersion($version)
    {
        /** @var \Zend_Db_Table_Row_Abstract $row */
        $row = $this->fetchAll()->current();
        $row->dbVersion = $version;
        $row->save();
    }

    public function exists()
    {
        return !empty($this->getAdapter()->describeTable('version'));
    }
}
